/*************************************************************************/
/*                                                                       */
/*                Centre for Speech Technology Research                  */
/*                     University of Edinburgh, UK                       */
/*                     Copyright (c) 1995,1996                           */
/*                        All Rights Reserved.                           */
/*                                                                       */
/*  Permission to use, copy, modify, distribute this software and its    */
/*  documentation for research, educational and individual use only, is  */
/*  hereby granted without fee, subject to the following conditions:     */
/*   1. The code must retain the above copyright notice, this list of    */
/*      conditions and the following disclaimer.                         */
/*   2. Any modifications must be clearly marked as such.                */
/*   3. Original authors' names are not deleted.                         */
/*  This software may not be used for commercial purposes without        */
/*  specific prior written permission from the authors.                  */
/*                                                                       */
/*  THE UNIVERSITY OF EDINBURGH AND THE CONTRIBUTORS TO THIS WORK        */
/*  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      */
/*  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   */
/*  SHALL THE UNIVERSITY OF EDINBURGH NOR THE CONTRIBUTORS BE LIABLE     */
/*  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    */
/*  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   */
/*  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          */
/*  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       */
/*  THIS SOFTWARE.                                                       */
/*                                                                       */
/*************************************************************************/

#ifndef __EST_SIGPR_H__
#define __EST_SIGPR_H__


#include "EST_Wave.h"
#include "EST_Track.h"
#include "EST_FMatrix.h"
#include "EST_Option.h"
#include "EST_TNamedEnum.h"
#include "EST_TBuffer.h"

/**@name Signal Processing
*/ //@{   

#include "sigpr/EST_filter.h"
//#include "sigpr/EST_lpc.h"
#include "sigpr/EST_pitchmark.h"
#include "sigpr/EST_fft.h"
//#include "sigpr/EST_PpMod.h"
//#include "sigpr/EST_delta.h"
//#include "sigpr/EST_energy.h"
#include "sigpr/EST_sig2fv.h"
#include "sigpr/EST_sigpr_utt.h"
#include "sigpr/EST_sigpr_frame.h"


#endif /* __EST_SIGPR_H__ */

//@}
